/* converter.hh
 * This file is part of mt-utils library
 * Copyright (c) 2004 by Stanislav Ievlev
 *
 * This file is covered by the GNU Library General Public License,
 * which should be included with mt-utils as the file COPYING.
 */

#ifndef MTQUERY_CONVERTER_HH__
#define MTQUERY_CONVERTER_HH__

#include <string>

#include <iconv.h>

#include "lang_info.hh"

/** convert between external and internal character represenations
 * @todo: will be rewritten to codecvt when codecvt in gcc will be ready
 */
class converter
{
    public:
    converter(mt::lang_code langnum);
    ~converter();
    
    std::string in(const std::string& str) const;
    std::string out(const std::string& str) const;
 private:
    std::string tr(const std::string& message, iconv_t id) const;

    iconv_t	       int_ext_; /**< from internal to external */
    iconv_t	       ext_int_; /**< from external to internal */
};
    
#endif
